unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, ScktComp, StdCtrls;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Mode_Server: TToolButton;
    Mode_Client: TToolButton;
    ServerSocket: TServerSocket;
    ClientSocket: TClientSocket;
    Button1: TButton;
    Memo1: TMemo;
    Edit_Msg: TEdit;
    Edit_Name: TEdit;
    Label1: TLabel;
    Edit_IP: TEdit;
    Label2: TLabel;
    Edit_Port: TEdit;
    procedure KeyPressLimit(Sender: TObject; var Key: Char);
    procedure KeyPressLimit2(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Edit_MsgKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SocketRead(Sender: TObject; Socket: TCustomWinSocket);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.KeyPressLimit(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #08]) then // ̓L['0'`'9',BackSpace/Delete ȊOȂ
  begin
    Key := #0; // ͂𖳎
    beep;
  end;
end;

procedure TForm1.KeyPressLimit2(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', '.', #08]) then // ̓L['0'`'9','.',BackSpace/Delete ȊOȂ
  begin
    Key := #0; // ͂𖳎
    beep;
  end;
end; // IPAhX͗p'.'ǉB

procedure TForm1.Button1Click(Sender: TObject);
begin
  // ڑ{^Ƃ
  if Mode_Server.Down then // T[o[hȂ
  begin
    ServerSocket.Port := StrToInt(Edit_Port.Text); // |[gԍw
    ServerSocket.Open;     // T[oƂĒʐMI[v
  end
  else                     // NCAg[hȂ
  begin
    ClientSocket.Address := Edit_IP.Text; // IPAhXw
    ClientSocket.Port := StrToInt(Edit_Port.Text); // |[gԍw
    ClientSocket.Open;     // NCAgƂĒʐMI[v
  end;

  Mode_Server.Enabled := False; // [hύXs\
  Mode_Client.Enabled := False;
  Edit_IP.ReadOnly := True; // IPAhXƃ|[gԍws\
  Edit_Port.ReadOnly := True;
  Button1.Enabled := False; // ڑ{^gps\
end;

procedure TForm1.Edit_MsgKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  str : String;
begin
  if Key = 13 then // EnterL[ꂽꍇ
  begin
    str := Edit_Name.Text + ' : ' + Edit_Msg.Text; // bZ[WɔҖǉ

    Memo1.Lines.Add(str); // gɕ\

    if Mode_Server.Down then // bZ[WM
      ServerSocket.Socket.Connections[0].SendText(str)
    else
      ClientSocket.Socket.SendText(str); //

    Edit_Msg.Text := ''; // MꂽbZ[W͏
  end;
end;

procedure TForm1.SocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add(Socket.ReceiveText); // bZ[WMA\
end;

end.
